/*Tetris made by Alexey Petrov aka Gluk 29.01.2004*/
/*
Thanks to beta-testers:
alessio
say
zabirnik
*/
#define DOWN_ARROW 20480
#define UP_ARROW 18432
#define ESC_KEY 283
#define SPACE_KEY 14624
#define LEFT_ARROW 19200
#define RIGHT_ARROW 19712
#define P_KEY 6512
#define ADD 1
#define DELETE 0
#define NEXT 1
#define NOT_NEXT 0
#define READ 1
#define WRITE 0
#include<bios.h>
#include<conio.h>
#include<dos.h>
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
char a[16][25];
int cx, cy, r, n;
long level, lines, score;
int next_n, next_r, next_cx, next_cy;
char* version = "0.5";
char best10title[10][10];
long best10score[10];
/*
a - ᨢ,  ࠭ ଠ  ஢ , ᫨  ᨢ
ࠢ ,  ⠬  祣, ᫨  ,   ᫮  梥
⨪

䨣,  ᥩ ,  ⥪饩

cx - ᫮ x न 業 ⥪饩 䨣,
cy - ᫮ y न 業 ⥪饩 䨣,
n -  ⥪饩 䨣,   ᥬ
r - ᫮, ।饥, ᪮쪮 ⥪ 䨣 ,  1  4,
lines - ᫮   ᮡ࠭ ப
level - ஢ , । ᪮  䨣, ࠢ lines/10
score - - 窮, ᫥ ப
*/
//------------------------------------
void draw(void);
int check_gameover();
void add_or_delete(int flag, int Next = NOT_NEXT);
void best_score(int flag);
//------------------------------------
void check_best_score(){
   for(int i=0; i<10; i++){
       if(score > best10score[i]){
	   for(int j=9; j>i; j--){
	       best10score[j] = best10score[j-1];
	       strcpy(best10title[j], best10title[j-1]);
	   }

	   gotoxy(32, 10);
	   cprintf("                ");
	   gotoxy(32, 11);
	   textcolor(5);
	   cprintf(" You are top 10 ");
	   gotoxy(32, 12);
	   cprintf(" Type your name ");
	   textcolor(2);
	   gotoxy(32, 13);
	   cprintf("                ");
	   gotoxy(32, 14);
	   cprintf("                ");
	   gotoxy(33, 13);
	   scanf("%s", &best10title[i]);

	   best10score[i] = score;
	   best_score(WRITE);
	   break;
       }
   }
}
void best_score(int flag){
   FILE* best_score_file=NULL;
   switch(flag){
       case READ:
	   best_score_file = fopen("best.txt", "rt");
	   if(best_score_file==NULL){
	       for(int i=0; i<10; i++){
		   strcpy(best10title[i], "NONE");
		   best10score[i] = 0;
	       }
	       break;
	   }
	   else{
	       for(int i=0; i<10; i++){
		   fscanf(best_score_file, "%s%ld", &best10title[i], &best10score[i]);
	       }
	       fclose(best_score_file);
	       break;
	   }
       case WRITE:
	   best_score_file = fopen("best.txt", "wt");
	   for(int i=0; i<10; i++){
	       fprintf(best_score_file, "%s\t%ld\n", best10title[i], best10score[i]);
	   }
	   fclose(best_score_file);
	   break;
   }
}
int sx(int x){
   return(2*x+32);
}
int sy(int y){
   return(25-y);
}
int born(){
   static int firsttime = 1;
   cx = 4;
   cy = 23;
   next_cx = 4;
   if(firsttime){
       firsttime = 0;
       next_r = 1+random(4);
       next_n = 1+random(7);
       if(next_n==4) next_cy = 22;
       else next_cy = 23;
       add_or_delete(ADD, NEXT);
   }
   add_or_delete(DELETE, NEXT);
   n = next_n;
   r = next_r;
   next_r = 1+random(4);
   next_n = 1+random(7);
   if(n==4) cy = 22;
   if(next_n==4) next_cy = 22;
   else next_cy = 23;
   if(check_gameover()==1) return 0;
   add_or_delete(ADD, NEXT);
   add_or_delete(ADD);
   draw();
   return 1;
}
int check_gameover(){
   switch(n){
       case 1:
	   switch(r){
	       case 1:
		   if(a[cx-1][cy+1]+a[cx-1][cy]+a[cx][cy]+a[cx+1][cy]!=0) return 1;
		   break;
	       case 2:
		   if(a[cx][cy+1]+a[cx][cy]+a[cx][cy-1]+a[cx-1][cy-1]!=0) return 1;
		   break;
	       case 3:
		   if(a[cx-1][cy]+a[cx][cy]+a[cx+1][cy]+a[cx+1][cy-1]!=0) return 1;
		   break;
	       case 4:
		   if(a[cx][cy+1]+a[cx][cy]+a[cx][cy-1]+a[cx+1][cy+1]!=0) return 1;
		   break;
	   }
	   break;
       case 2:
	   switch(r){
	       case 1:
		   if(a[cx][cy]+a[cx-1][cy]+a[cx+1][cy]+a[cx][cy+1]!=0) return 1;
		   break;
	       case 2:
		   if(a[cx][cy]+a[cx-1][cy]+a[cx][cy-1]+a[cx][cy+1]!=0) return 1;
		   break;
	       case 3:
		   if(a[cx][cy]+a[cx-1][cy]+a[cx+1][cy]+a[cx][cy-1]!=0) return 1;
		   break;
	       case 4:
		   if(a[cx][cy]+a[cx][cy-1]+a[cx][cy+1]+a[cx+1][cy]!=0) return 1;
		   break;
	   }
	   break;
       case 3:
	   if(a[cx][cy]+a[cx-1][cy]+a[cx-1][cy+1]+a[cx][cy+1]!=0) return 1;
	   break;
       case 4:
	   switch(r){
	       case 1:
	       case 3:
		   if(a[cx][cy+2]+a[cx][cy+1]+a[cx][cy]+a[cx][cy-1]!=0) return 1;
		   break;
	       case 2:
	       case 4:
		   if(a[cx-2][cy]+a[cx-1][cy]+a[cx][cy]+a[cx+1][cy]!=0) return 1;
		   break;
	   }
	   break;
       case 5:
	   switch(r){
	       case 1:
		   if(a[cx][cy]+a[cx-1][cy]+a[cx+1][cy]+a[cx+1][cy+1]!=0) return 1;
		   break;
	       case 2:
		   if(a[cx][cy-1]+a[cx][cy]+a[cx][cy+1]+a[cx-1][cy+1]!=0) return 1;
		   break;
	       case 3:
		   if(a[cx][cy]+a[cx-1][cy]+a[cx+1][cy]+a[cx-1][cy-1]!=0) return 1;
		   break;
	       case 4:
		   if(a[cx][cy-1]+a[cx][cy]+a[cx][cy+1]+a[cx+1][cy-1]!=0) return 1;
		   break;
	   }
	   break;
       case 6:
	   switch(r){
	       case 1:
		   if(a[cx][cy]+a[cx-1][cy]+a[cx][cy+1]+a[cx+1][cy+1]!=0) return 1;
		   break;
	       case 2:
		   if(a[cx][cy]+a[cx-1][cy]+a[cx-1][cy+1]+a[cx][cy-1]!=0) return 1;
		   break;
	       case 3:
		   if(a[cx][cy]+a[cx+1][cy]+a[cx][cy-1]+a[cx-1][cy-1]!=0) return 1;
		   break;
	       case 4:
		   if(a[cx][cy]+a[cx][cy+1]+a[cx+1][cy]+a[cx+1][cy-1]!=0) return 1;
		   break;
	   }
	   break;
       case 7:
	   switch(r){
	       case 1:
		   if(a[cx][cy]+a[cx-1][cy+1]+a[cx][cy+1]+a[cx+1][cy]!=0) return 1;
		   break;
	       case 2:
		   if(a[cx][cy]+a[cx][cy+1]+a[cx-1][cy]+a[cx-1][cy-1]!=0) return 1;
		   break;
	       case 3:
		   if(a[cx][cy]+a[cx-1][cy]+a[cx][cy-1]+a[cx+1][cy-1]!=0) return 1;
		   break;
	       case 4:
		   if(a[cx][cy]+a[cx+1][cy+1]+a[cx+1][cy]+a[cx][cy-1]!=0) return 1;
		   break;
	   }
	   break;
   }
   return 0;
}
void add_or_delete(int flag, int Next){
   int col, tmp_n, tmp_x, tmp_y, tmp_r;
   if(Next==NEXT){
       /* ६ 塞 ⥪ 䨣  ᫥ */
       tmp_x = cx;
       tmp_y = cy;
       tmp_n = n;
       tmp_r = r;
       n = next_n;
       cx = next_cx + 8;
       cy = next_cy;
       r = next_r;
   }
   col = n;
   if(flag==DELETE) col=0;
   switch(n){
       case 1:
	   switch(r){
	       case 1:
		   a[cx-1][cy+1]=col;
		   a[cx-1][cy]=col;
		   a[cx][cy]=col;
		   a[cx+1][cy]=col;
		   break;
	       case 2:
		   a[cx][cy+1]=col;
		   a[cx][cy]=col;
		   a[cx][cy-1]=col;
		   a[cx-1][cy-1]=col;
		   break;
	       case 3:
		   a[cx-1][cy]=col;
		   a[cx][cy]=col;
		   a[cx+1][cy]=col;
		   a[cx+1][cy-1]=col;
		   break;
	       case 4:
		   a[cx][cy+1]=col;
		   a[cx][cy]=col;
		   a[cx][cy-1]=col;
		   a[cx+1][cy+1]=col;
		   break;
	   }
	   break;
       case 2:
	   switch(r){
	       case 1:
		   a[cx][cy]=col;
		   a[cx-1][cy]=col;
		   a[cx+1][cy]=col;
		   a[cx][cy+1]=col;
		   break;
	       case 2:
		   a[cx][cy]=col;
		   a[cx-1][cy]=col;
		   a[cx][cy-1]=col;
		   a[cx][cy+1]=col;
		   break;
	       case 3:
		   a[cx][cy]=col;
		   a[cx-1][cy]=col;
		   a[cx+1][cy]=col;
		   a[cx][cy-1]=col;
		   break;
	       case 4:
		   a[cx][cy]=col;
		   a[cx][cy-1]=col;
		   a[cx][cy+1]=col;
		   a[cx+1][cy]=col;
		   break;
	   }
	   break;
       case 3:
	   a[cx][cy]=col;
	   a[cx-1][cy]=col;
	   a[cx-1][cy+1]=col;
	   a[cx][cy+1]=col;
	   break;
       case 4:
	   switch(r){
	       case 1:
	       case 3:
		   a[cx][cy+2]=col;
		   a[cx][cy+1]=col;
		   a[cx][cy]=col;
		   a[cx][cy-1]=col;
		   break;
	       case 2:
	       case 4:
		   a[cx-2][cy]=col;
		   a[cx-1][cy]=col;
		   a[cx][cy]=col;
		   a[cx+1][cy]=col;
		   break;
	   }
	   break;
       case 5:
	   switch(r){
	       case 1:
		   a[cx][cy]=col;
		   a[cx-1][cy]=col;
		   a[cx+1][cy]=col;
		   a[cx+1][cy+1]=col;
		   break;
	       case 2:
		   a[cx][cy-1]=col;
		   a[cx][cy]=col;
		   a[cx][cy+1]=col;
		   a[cx-1][cy+1]=col;
		   break;
	       case 3:
		   a[cx][cy]=col;
		   a[cx-1][cy]=col;
		   a[cx+1][cy]=col;
		   a[cx-1][cy-1]=col;
		   break;
	       case 4:
		   a[cx][cy-1]=col;
		   a[cx][cy]=col;
		   a[cx][cy+1]=col;
		   a[cx+1][cy-1]=col;
		   break;
	   }
	   break;
       case 6:
	   switch(r){
	       case 1:
		   a[cx][cy]=col;
		   a[cx-1][cy]=col;
		   a[cx][cy+1]=col;
		   a[cx+1][cy+1]=col;
		   break;
	       case 2:
		   a[cx][cy]=col;
		   a[cx-1][cy]=col;
		   a[cx-1][cy+1]=col;
		   a[cx][cy-1]=col;
		   break;
	       case 3:
		   a[cx][cy]=col;
		   a[cx+1][cy]=col;
		   a[cx][cy-1]=col;
		   a[cx-1][cy-1]=col;
		   break;
	       case 4:
		   a[cx][cy]=col;
		   a[cx][cy+1]=col;
		   a[cx+1][cy]=col;
		   a[cx+1][cy-1]=col;
		   break;
	   }
	   break;
       case 7:
	   switch(r){
	       case 1:
		   a[cx][cy]=col;
		   a[cx-1][cy+1]=col;
		   a[cx][cy+1]=col;
		   a[cx+1][cy]=col;
		   break;
	       case 2:
		   a[cx][cy]=col;
		   a[cx][cy+1]=col;
		   a[cx-1][cy]=col;
		   a[cx-1][cy-1]=col;
		   break;
	       case 3:
		   a[cx][cy]=col;
		   a[cx-1][cy]=col;
		   a[cx][cy-1]=col;
		   a[cx+1][cy-1]=col;
		   break;
	       case 4:
		   a[cx][cy]=col;
		   a[cx+1][cy+1]=col;
		   a[cx+1][cy]=col;
		   a[cx][cy-1]=col;
		   break;
	   }
	   break;
   }
   if(Next==NEXT){
       /*   ,    ⠫ :) */
       cx = tmp_x;
       cy = tmp_y;
       n = tmp_n;
       r = tmp_r;
   }
}
int down(){
   switch(n){
       case 1:
	   switch(r){
	       case 1:
		   if(a[cx-1][cy-1]+a[cx][cy-1]+a[cx+1][cy-1]!=0) return 1;
		   if(cy==0) return 1;
		   break;
	       case 2:
		   if(a[cx-1][cy-2]+a[cx][cy-2]+a[cx-1][cy-2]!=0) return 1;
		   if(cy==1) return 1;
		   break;
	       case 3:
		   if(a[cx-1][cy-1]+a[cx][cy-1]+a[cx+1][cy-2]!=0) return 1;
		   if(cy==1) return 1;
		   break;
	       case 4:
		   if(a[cx][cy-2]+a[cx+1][cy]!=0) return 1;
		   if(cy==1) return 1;
		   break;
	   }
	   break;
       case 2:
	   switch(r){
	       case 1:
		   if(a[cx-1][cy-1]+a[cx][cy-1]+a[cx+1][cy-1]!=0) return 1;
		   if(cy==0) return 1;
		   break;
	       case 2:
		   if(a[cx-1][cy-1]+a[cx][cy-2]!=0) return 1;
		   if(cy==1) return 1;
		   break;
	       case 3:
		   if(a[cx-1][cy-1]+a[cx][cy-2]+a[cx+1][cy-1]!=0) return 1;
		   if(cy==1) return 1;
		   break;
	       case 4:
		   if(a[cx+1][cy-1]+a[cx][cy-2]!=0) return 1;
		   if(cy==1) return 1;
		   break;
	   }
	   break;
       case 3:
	   if(a[cx][cy-1]+a[cx-1][cy-1]!=0) return 1;
	   if(cy==0) return 1;
	   break;
       case 4:
	   switch(r){
	       case 1:
	       case 3:
		   if(a[cx][cy-2]!=0) return 1;
		   if(cy==1) return 1;
		   break;
	       case 2:
	       case 4:
		   if(a[cx-2][cy-1]+a[cx-1][cy-1]+a[cx][cy-1]+a[cx+1][cy-1]!=0) return 1;
		   if(cy==0) return 1;
		   break;
	   }
	   break;
       case 5:
	   switch(r){
	       case 1:
		   if(a[cx-1][cy-1]+a[cx][cy-1]+a[cx+1][cy-1]!=0) return 1;
		   if(cy==0) return 1;
		   break;
	       case 2:
		   if(a[cx-1][cy]+a[cx][cy-2]!=0) return 1;
		   if(cy==1) return 1;
		   break;
	       case 3:
		   if(a[cx][cy-1]+a[cx-1][cy-2]+a[cx+1][cy-1]!=0) return 1;
		   if(cy==1) return 1;
		   break;
	       case 4:
		   if(a[cx][cy-2]+a[cx+1][cy-2]!=0) return 1;
		   if(cy==1) return 1;
		   break;
	   }
	   break;
       case 6:
	   switch(r){
	       case 1:
		   if(a[cx-1][cy-1]+a[cx][cy-1]+a[cx+1][cy]!=0) return 1;
		   if(cy==0) return 1;
		   break;
	       case 2:
		   if(a[cx-1][cy-1]+a[cx][cy-2]!=0) return 1;
		   if(cy==1) return 1;
		   break;
	       case 3:
		   if(a[cx-1][cy-2]+a[cx][cy-2]+a[cx+1][cy-1]!=0) return 1;
		   if(cy==1) return 1;
		   break;
	       case 4:
		   if(a[cx][cy-1]+a[cx+1][cy-2]!=0) return 1;
		   if(cy==1) return 1;
		   break;
	   }
	   break;
       case 7:
	   switch(r){
	       case 1:
		   if(a[cx-1][cy]+a[cx][cy-1]+a[cx+1][cy-1]!=0) return 1;
		   if(cy==0) return 1;
		   break;
	       case 2:
		   if(a[cx-1][cy-2]+a[cx][cy-1]!=0) return 1;
		   if(cy==1) return 1;
		   break;
	       case 3:
		   if(a[cx-1][cy-1]+a[cx][cy-2]+a[cx+1][cy-2]!=0) return 1;
		   if(cy==1) return 1;
		   break;
	       case 4:
		   if(a[cx][cy-2]+a[cx+1][cy-1]!=0) return 1;
		   if(cy==1) return 1;
		   break;
	   }
	   break;
   }
   add_or_delete(DELETE);
   cy-=1;
   add_or_delete(ADD);
   draw();
   return 0;
}
void left(){
   switch(n){
       case 1:
	   switch(r){
	       case 1:
		   if(a[cx-2][cy]+a[cx-2][cy+1]!=0) return;
		   if(cx==1) return;
		   break;
	       case 2:
		   if(a[cx-2][cy-1]+a[cx-1][cy]+a[cx-1][cy+1]!=0) return;
		   if(cx==1) return;
		   break;
	       case 3:
		   if(a[cx-2][cy]+a[cx][cy-1]!=0) return;
		   if(cx==1) return;
		   break;
	       case 4:
		   if(a[cx-1][cy-1]+a[cx-1][cy]+a[cx-1][cy+1]!=0) return;
		   if(cx==0) return;
		   break;

	   }
	   break;
       case 2:
	   switch(r){
	       case 1:
		   if(a[cx-2][cy]+a[cx-1][cy+1]!=0) return;
		   if(cx==1) return;
		   break;
	       case 2:
		   if(a[cx-2][cy]+a[cx-1][cy+1]+a[cx-1][cy-1]!=0) return;
		   if(cx==1) return;
		   break;
	       case 3:
		   if(a[cx-2][cy]+a[cx-1][cy-1]!=0) return;
		   if(cx==1) return;
		   break;
	       case 4:
		   if(a[cx-1][cy]+a[cx-1][cy+1]+a[cx-1][cy-1]!=0) return;
		   if(cx==0) return;
		   break;
	   }
	   break;
       case 3:
	   if(a[cx-2][cy]+a[cx-2][cy+1]!=0) return;
	   if(cx==1) return;
	   break;
       case 4:
	   switch(r){
	       case 1:
	       case 3:
		   if(a[cx-1][cy-1]+a[cx-1][cy]+a[cx-1][cy+1]+a[cx-1][cy+2]!=0) return;
		   if(cx==0) return;
		   break;
	       case 2:
	       case 4:
		   if(a[cx-3][cy]!=0) return;
		   if(cx==2) return;
		   break;
	   }
	   break;
       case 5:
	   switch(r){
	       case 1:
		   if(a[cx-2][cy]+a[cx][cy+1]!=0) return;
		   if(cx==1) return;
		   break;
	       case 2:
		   if(a[cx-2][cy+1]+a[cx-1][cy-1]+a[cx-1][cy]!=0) return;
		   if(cx==1) return;
		   break;
	       case 3:
		   if(a[cx-2][cy]+a[cx-2][cy-1]!=0) return;
		   if(cx==1) return;
		   break;
	       case 4:
		   if(a[cx-1][cy+1]+a[cx-1][cy-1]+a[cx-1][cy]!=0) return;
		   if(cx==0) return;
		   break;
	   }
	   break;
       case 6:
	   switch(r){
	       case 1:
		   if(a[cx-2][cy]+a[cx-1][cy+1]!=0) return;
		   if(cx==1) return;
		   break;
	       case 2:
		   if(a[cx-2][cy]+a[cx-2][cy+1]+a[cx-1][cy-1]!=0) return;
		   if(cx==1) return;
		   break;
	       case 3:
		   if(a[cx-1][cy]+a[cx-2][cy-1]!=0) return;
		   if(cx==1) return;
		   break;
	       case 4:
		   if(a[cx-1][cy]+a[cx-1][cy+1]+a[cx][cy-1]!=0) return;
		   if(cx==0) return;
		   break;
	   }
	   break;
       case 7:
	   switch(r){
	       case 1:
		   if(a[cx-2][cy+1]+a[cx-1][cy]!=0) return;
		   if(cx==1) return;
		   break;
	       case 2:
		   if(a[cx-2][cy]+a[cx-1][cy+1]+a[cx-2][cy-1]!=0) return;
		   if(cx==1) return;
		   break;
	       case 3:
		   if(a[cx-2][cy]+a[cx-1][cy-1]!=0) return;
		   if(cx==1) return;
		   break;
	       case 4:
		   if(a[cx][cy+1]+a[cx-1][cy]+a[cx-1][cy-1]!=0) return;
		   if(cx==0) return;
		   break;
	   }
	   break;
   }
   add_or_delete(DELETE);
   cx-=1;
   add_or_delete(ADD);
   draw();
}
void right(){
   switch(n){
       case 1:
	   switch(r){
	       case 1:
		   if(a[cx+2][cy]+a[cx][cy+1]!=0) return;
		   if(cx==6) return;
		   break;
	       case 2:
		   if(a[cx+1][cy-1]+a[cx+1][cy]+a[cx+1][cy+1]!=0) return;
		   if(cx==7) return;
		   break;
	       case 3:
		   if(a[cx+2][cy]+a[cx+2][cy-1]!=0) return;
		   if(cx==6) return;
		   break;
	       case 4:
		   if(a[cx+2][cy+1]+a[cx+1][cy]+a[cx+1][cy-1]!=0) return;
		   if(cx==6) return;
		   break;
	   }
	   break;
       case 2:
	   switch(r){
	       case 1:
		   if(a[cx+2][cy]+a[cx+1][cy+1]!=0) return;
		   if(cx==6) return;
		   break;
	       case 2:
		   if(a[cx+1][cy]+a[cx+1][cy+1]+a[cx+1][cy-1]!=0) return;
		   if(cx==7) return;
		   break;
	       case 3:
		   if(a[cx+2][cy]+a[cx+1][cy-1]!=0) return;
		   if(cx==6) return;
		   break;
	       case 4:
		   if(a[cx+2][cy]+a[cx+1][cy+1]+a[cx+1][cy-1]!=0) return;
		   if(cx==6) return;
		   break;
	   }
	   break;
       case 3:
	   if(a[cx+1][cy]+a[cx+1][cy+1]!=0) return;
	   if(cx==7) return;
	   break;
       case 4:
	   switch(r){
	       case 1:
	       case 3:
		   if(a[cx+1][cy+2]+a[cx+1][cy+1]+a[cx+1][cy]+a[cx+1][cy-1]!=0) return;
		   if(cx==7) return;
		   break;
	       case 2:
	       case 4:
		   if(a[cx+2][cy]!=0) return;
		   if(cx==6) return;
		   break;
	   }
	   break;
       case 5:
	   switch(r){
	       case 1:
		   if(a[cx+2][cy]+a[cx+2][cy+1]!=0) return;
		   if(cx==6) return;
		   break;
	       case 2:
		   if(a[cx+1][cy]+a[cx+1][cy+1]+a[cx+1][cy-1]!=0) return;
		   if(cx==7) return;
		   break;
	       case 3:
		   if(a[cx+2][cy]+a[cx][cy-1]!=0) return;
		   if(cx==6) return;
		   break;
	       case 4:
		   if(a[cx+1][cy]+a[cx+1][cy+1]+a[cx+2][cy-1]!=0) return;
		   if(cx==6) return;
		   break;
	   }
	   break;
       case 6:
	   switch(r){
	       case 1:
		   if(a[cx+2][cy+1]+a[cx+1][cy]!=0) return;
		   if(cx==6) return;
		   break;
	       case 2:
		   if(a[cx][cy+1]+a[cx+1][cy]+a[cx+1][cy-1]!=0) return;
		   if(cx==7) return;
		   break;
	       case 3:
		   if(a[cx+2][cy]+a[cx+1][cy-1]!=0) return;
		   if(cx==6) return;
		   break;
	       case 4:
		   if(a[cx+1][cy+1]+a[cx+2][cy]+a[cx+2][cy-1]!=0) return;
		   if(cx==6) return;
		   break;
	   }
	   break;
       case 7:
	   switch(r){
	       case 1:
		   if(a[cx+2][cy]+a[cx+1][cy+1]!=0) return;
		   if(cx==6) return;
		   break;
	       case 2:
		   if(a[cx+1][cy+1]+a[cx+1][cy]+a[cx][cy-1]!=0) return;
		   if(cx==7) return;
		   break;
	       case 3:
		   if(a[cx+1][cy]+a[cx+2][cy-1]!=0) return;
		   if(cx==6) return;
		   break;
	       case 4:
		   if(a[cx+2][cy+1]+a[cx+2][cy]+a[cx+1][cy-1]!=0) return;
		   if(cx==6) return;
		   break;
	   }
	   break;
   }
   add_or_delete(DELETE);
   cx+=1;
   add_or_delete(ADD);
   draw();
}
void rotate_left(){
   switch(n){
       case 1:
	   switch(r){
	       case 1:
		   if(a[cx][cy+1]+a[cx+1][cy+1]+a[cx][cy+1]!=0) return;
		   if(cy==0) return;
		   add_or_delete(DELETE);
		   r++;
		   add_or_delete(ADD);
		   draw();
		   break;
	       case 2:
		   if(a[cx-1][cy]+a[cx+1][cy]!=0) return;
		   if(cx==7) return;
		   add_or_delete(DELETE);
		   r++;
		   add_or_delete(ADD);
		   draw();
		   break;
	       case 3:
		   if(a[cx][cy+1]+a[cx][cy-1]+a[cx-1][cy-1]!=0) return;
		   add_or_delete(DELETE);
		   r++;
		   add_or_delete(ADD);
		   draw();
		   break;
	       case 4:
		   if(a[cx-1][cy]+a[cx-1][cy+1]+a[cx+1][cy]!=0) return;
		   if(cx==0) return;
		   add_or_delete(DELETE);
		   r=1;
		   add_or_delete(ADD);
		   draw();
		   break;
	   }
	   break;
       case 2:
	   switch(r){
	       case 1:
		   if(a[cx][cy-1]!=0) return;
		   if(cy==0) return;
		   add_or_delete(DELETE);
		   r++;
		   add_or_delete(ADD);
		   draw();
		   break;
	       case 2:
		   if(a[cx+1][cy]!=0) return;
		   if(cx==7) return;
		   add_or_delete(DELETE);
		   r++;
		   add_or_delete(ADD);
		   draw();
		   break;
	       case 3:
		   if(a[cx][cy+1]!=0) return;
		   add_or_delete(DELETE);
		   r++;
		   add_or_delete(ADD);
		   draw();
		   break;
	       case 4:
		   if(a[cx-1][cy]!=0) return;
		   if(cx==0) return;
		   add_or_delete(DELETE);
		   r=1;
		   add_or_delete(ADD);
		   draw();
		   break;
	   }
	   break;
       case 3:
	   break;
       case 4:
	   switch(r){
	       case 1:
	       case 3:
		   if(a[cx-2][cy]+a[cx-1][cy]+a[cx+1][cy]!=0) return;
		   if(cx<2 || cx==7) return;
		   add_or_delete(DELETE);
		   r++;
		   add_or_delete(ADD);
		   draw();
		   break;
	       case 2:
	       case 4:
		   if(a[cx][cy+2]+a[cx][cy+1]+a[cx][cy-1]!=0) return;
		   if(cy==1) return;
		   add_or_delete(DELETE);
		   r=1;
		   add_or_delete(ADD);
		   draw();
		   break;
	   }
	   break;
       case 5:
	   switch(r){
	       case 1:
		   if(a[cx][cy+1]+a[cx-1][cy+1]+a[cx][cy-1]!=0) return;
		   if(cy==0) return;
		   add_or_delete(DELETE);
		   r++;
		   add_or_delete(ADD);
		   draw();
		   break;
	       case 2:
		   if(a[cx-1][cy]+a[cx-1][cy-1]+a[cx+1][cy]!=0) return;
		   if(cx==7) return;
		   add_or_delete(DELETE);
		   r++;
		   add_or_delete(ADD);
		   draw();
		   break;
	       case 3:
		   if(a[cx][cy-1]+a[cx+1][cy-1]+a[cx][cy+1]!=0) return;
		   add_or_delete(DELETE);
		   r++;
		   add_or_delete(ADD);
		   draw();
		   break;
	       case 4:
		   if(a[cx-1][cy]+a[cx+1][cy]+a[cx+1][cy+1]!=0) return;
		   if(cx==0) return;
		   add_or_delete(DELETE);
		   r=1;
		   add_or_delete(ADD);
		   draw();
		   break;
	   }
	   break;
       case 6:
	   switch(r){
	       case 1:
		   if(a[cx-1][cy+1]+a[cx][cy-1]!=0) return;
		   if(cy==0) return;
		   add_or_delete(DELETE);
		   r++;
		   add_or_delete(ADD);
		   draw();
		   break;
	       case 2:
		   if(a[cx-1][cy-1]+a[cx+1][cy]!=0) return;
		   if(cx==7) return;
		   add_or_delete(DELETE);
		   r++;
		   add_or_delete(ADD);
		   draw();
		   break;
	       case 3:
		   if(a[cx][cy+1]+a[cx+1][cy-1]!=0) return;
		   add_or_delete(DELETE);
		   r++;
		   add_or_delete(ADD);
		   draw();
		   break;
	       case 4:
		   if(a[cx-1][cy]+a[cx+1][cy+1]!=0) return;
		   if(cx==0) return;
		   add_or_delete(DELETE);
		   r=1;
		   add_or_delete(ADD);
		   draw();
		   break;
	   }
	   break;
       case 7:
	   switch(r){
	       case 1:
		   if(a[cx-1][cy]+a[cx-1][cy-1]!=0) return;
		   if(cy==0) return;
		   add_or_delete(DELETE);
		   r++;
		   add_or_delete(ADD);
		   draw();
		   break;
	       case 2:
		   if(a[cx][cy-1]+a[cx+1][cy-1]!=0) return;
		   if(cx==7) return;
		   add_or_delete(DELETE);
		   r++;
		   add_or_delete(ADD);
		   draw();
		   break;
	       case 3:
		   if(a[cx+1][cy]+a[cx+1][cy+1]!=0) return;
		   add_or_delete(DELETE);
		   r++;
		   add_or_delete(ADD);
		   draw();
		   break;
	       case 4:
		   if(a[cx][cy+1]+a[cx-1][cy+1]!=0) return;
		   if(cx==0) return;
		   add_or_delete(DELETE);
		   r=1;
		   add_or_delete(ADD);
		   draw();
		   break;
	   }
	   break;
   }
}
void show_info(){
   /*show level and lines number*/
   for(int i=0; i<10; i++){
       for(int j=0; j<3; j++){
	   textcolor(0);
	   gotoxy(i+1, j+1);
	   cprintf("");
       }
   }

   textcolor(15);
   gotoxy(1, 1);
   cprintf("level: %ld", level);

   gotoxy(1, 2);
   cprintf("lines: %ld", lines);

   gotoxy(1, 3);
   cprintf("score: %ld", score);

}
void check_line(){
   int flag=0;
   for(int j=0; j<25; j++){
       char line = 0;
       for(int i=0; i<8; i++){
	   if(a[i][j]!=0) line++;
       }
       if(line == 8){
	   for(int nj = j; nj<24; nj++){
	       for(i=0; i<8; i++){
		   a[i][nj] = a[i][nj+1];
	       }
	   }
	   for(i=0; i<8; i++) a[i][24] = 0;
	   j--;
	   flag++;
	   lines++;
	   if(lines%10 == 0){
	       level++;
	   }
       }
   }
   if(flag!=0){
       switch(flag){
	   case 1:
		 score+=10;
		 break;
	   case 2:
		 score+=25;
		 break;
	   case 3:
		 score+=50;
		 break;
	   case 4:
		 score+=100;
		 break;
       }
       draw();
       show_info();
   }
}
void init(){
   int i,j;
   randomize();
   level = 0;
   lines = 0;
   score = 0;
   for(i=0; i<16; i++){
       for(j=0; j<25; j++) a[i][j] = 0;
   }
   for(i=0; i<50; i++) printf("\n");
   textcolor(15);
   for(j=0; j<25; j++){
       gotoxy(sx(-1), sy(j));
       cprintf(" ");
       gotoxy(sx(8), sy(j));
       cprintf("");
   }
   gotoxy(1, 20);
   cprintf("Esc: exit");
   gotoxy(1, 21);
   cprintf("Space: restart");
   gotoxy(1, 22);
   cprintf("P: pause");
   textcolor(7);
   gotoxy(1, 25);
   cprintf("Version: %s", version);
   born();
   add_or_delete(ADD);
   draw();
   show_info();
   best_score(READ);
   gotoxy(60, 15);
   textcolor(4);
   cprintf("Top 10 players:");
   textcolor(2);
   for(i=0; i<10; i++){
       gotoxy(60, 16+i);
       cprintf("%s", best10title[i]);
       gotoxy(71, 16+i);
       cprintf("%ld", best10score[i]);
   }
}
void hide_cursor(){
   asm{
       mov ah, 2
       mov bh, 0
       mov dh, 25
       mov dl, 80
       int 0x10
   }
}
void draw(){
   int i,j;
   for(j=0; j<25; j++){
       for(i=0; i<8; i++){
	   textcolor(a[i][j]);
	   gotoxy(sx(i), sy(j));
	   cprintf("");
	   hide_cursor();
       }
   }
   for(j=20; j<25; j++){
       for(i=10; i<16; i++){
	   textcolor(a[i][j]);
	   gotoxy(sx(i), sy(j));
	   cprintf("");
	   hide_cursor();
       }
   }
}
void main(){
   int Exit;
   float cur_time, prev_time;
   struct time ct;
   float time_delay;
start:
   Exit=0;
   cur_time = 0;
   prev_time = 0;
   gettime(&ct);
   init();
   cur_time = ct.ti_hour*60.0*60.0 + ct.ti_min*60.0 + ct.ti_sec + ct.ti_hund/100.0;
   prev_time = cur_time;
   while(!Exit){
       gettime(&ct);
       cur_time = ct.ti_hour*60.0*60.0 + ct.ti_min*60.0 + ct.ti_sec + ct.ti_hund/100.0;
       if(bioskey(1)!=0){
	   int key = bioskey(0);
	   switch(key){
	       case ESC_KEY:
		   Exit = 1;
		   break;
	       case LEFT_ARROW:
		   left();
		   break;
	       case RIGHT_ARROW:
		   right();
		   break;
	       case UP_ARROW:
		   rotate_left();
		   break;
	       case DOWN_ARROW:
		   while(!down());
		   score += level%10;
		   check_line();
		   show_info();
		   if(born()==0) Exit = 1;
		   prev_time = cur_time + (0.5 - (level%10)*0.04);
		   break;
	       case SPACE_KEY:
		   check_best_score();
		   goto start;
	       case P_KEY:
		   textcolor(2);
		   gotoxy(32, 10);
		   cprintf("                ");
		   gotoxy(32, 11);
		   cprintf("     PAUSE      ");
		   gotoxy(32, 12);
		   cprintf("Any key to play ");
		   gotoxy(32, 13);
		   cprintf("                ");
		   hide_cursor();
		   while(bioskey(1)==0);
		   break;
	   }
      }
      time_delay = 0.5 - (level%10)*0.04;
      if(cur_time - prev_time >= time_delay){
	   prev_time = cur_time;
	   if(down()){
	       score += level%10;
	       check_line();
	       show_info();
	       if(born()==0) Exit = 1;
	   }
      }
   }
   check_best_score();
   gotoxy(32, 10);
   cprintf("                ");
   gotoxy(32, 11);
   textcolor(5);
   cprintf("   Game Over    ");
   gotoxy(32, 12);
   cprintf("                ");
   gotoxy(32, 13);
   textcolor(2);
   cprintf("   Es: exit    ");
   gotoxy(32, 14);
   cprintf("                ");
   gotoxy(32, 15);
   cprintf(" Space: restart ");
   gotoxy(32, 16);
   cprintf("                ");

   hide_cursor();

   while(bioskey(1)==0){
       int key = bioskey(0);
       if(key==ESC_KEY) break;
       if(key==SPACE_KEY) goto start;
   }
}